/*                                                           08-17-94 10:28pm
 ****************************************************************************
 *
 *   BGF.H             Header File for BGI CHR-fonts handling package.
 *   Version 1.00.01
 *
 * Copyright (c) Alexander V. Loukyanets, 1994.  All rights reserved.
 *
 ****************************************************************************
 */

#ifndef _BGF_H_Module
#define _BGF_H_Module   1


/*
 ****************************************************************************
 *   Constant definitions
 */

#define BGFE_OK             0
#define BGFE_OPNERRFNTFIL  -1
#define BGFE_REAERRFNTFIL  -2
#define BGFE_ITSNOTFNTFIL  -3
#define BGFE_MEMALLOC_ERR  -4
#define BGFE_NO_REGDFONTS  -5
#define BGFE_NO_SUCH_FONT  -6


/*
 ****************************************************************************
 *   Types definitions
 */

typedef struct {
  unsigned char  *FileName;
  unsigned char  *FontName;
  signed char    *FontVers;
  short           CharsNum;
  unsigned char   CharStart;
  signed char     FillFlag;
  signed char     UprMargin;
  signed char     LwrMargin;
} t_BGFFontInfo;


/*
 ****************************************************************************
 *   Prototypes
 */

int     bgfRegisterFont     ( char *FileName );
int     bgfRegisterFonts    ( char *FileNames );
int     bgfUnregisterFonts  ( void );
int     bgfDrawText         ( int fontIndex, int color, int x, int y,
                              int Height, double ExtCoef, char *Text );
int     bgfGetNRegdFonts    ( void );
int     bgfGetFontInfo      ( int fontIndex, t_BGFFontInfo *fi );


#endif
/****************************************************************************
*** end of BGF.H ***/