/*                                                           08-11-94 05:53pm
 ****************************************************************************
 *
 *   BGFTEST.C        Sample Program of using BGI CHR-fonts handling
 *                    package (BGF package)
 *
 * Copyright (c) Alexander V. Loukyanets, 1994
 *
 ****************************************************************************
 */

#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include "fg.h"
#include "bgf.h"


/*
 ****************************************************************************
 *   Globals definitions
 */

int     nFonts;


/*
 ****************************************************************************
 *   Prototypes
 */

void      Exiting        ( void );
int       ParseCMDLine   ( int argc, char **argv );
int       Process        ( void );


/****************************************************************************/
/****************************************************************************/
/****************************************************************************/

/*
 ****************************************************************************
 */

int main (int argc, char **argv )
{
  int   errcode, i;

  atexit( Exiting );

  if ( (errcode=ParseCMDLine( argc, argv )) != 0 ) exit( errcode );
  exit        ( Process() );
}

/*
 ****************************************************************************
 */

void Exiting()
{
  printf("\nExiting...");

  if ( bgfGetNRegdFonts() != 0 ) {
    bgfUnregisterFonts();
    if ( bgfGetNRegdFonts() == 0 ) printf("\nFonts unregistered.");
    else printf("\nCan't unregister font(s).");
  }

  printf("\n\nHit any key to exit..."); getch();
}

/*
 ****************************************************************************
 */

int ParseCMDLine( int argc, char **argv )
{
  int       i;

  if  ( argc<=1 )             bgfRegisterFonts( "*.chr" );
  else for (i=1; i<argc; i++) bgfRegisterFonts( argv[i] );

  if ( (nFonts=bgfGetNRegdFonts()) <= 0 ) {
    printf("\nNo registered fonts.");
    return( -1 );
  }
  else
    printf("\n%d font(s) successfully registered.",nFonts);

  return( 0 );
}

/*
 ****************************************************************************
 */

int Process( void )
{
  int             i;
  t_BGFFontInfo   fi;
  char            buf[133];

  for ( i=1; i<=nFonts; i++ ) {
    printf("\n---------------------\n\tfontIndex\t= %d",i);
    if ( bgfGetFontInfo( i, &fi ) != BGFE_OK )
      printf("\nCan't get fontInfo for fontIndex=%d",i);
    else {
      printf("\n\tFileName\t= %s",  fi.FileName);
      printf("\n\tFontName\t= %s",  fi.FontName);
      printf("\n\tFontVers\t= %d,%d,%d", fi.FontVers[0], fi.FontVers[1], fi.FontVers[2]);
      printf("\n\tCharsNum\t= %d",  fi.CharsNum);
      printf("\n\tCharStart\t= '%c' (%Xh)", fi.CharStart, fi.CharStart);
      printf("\n\tFillFlag\t= %d",  fi.FillFlag);
      printf("\n\tUprMargin\t= %d", fi.UprMargin);
      printf("\n\tLwrMargin\t= %d", fi.LwrMargin);
      printf("\n\n\n Hit any key for continue...  (Ctrl/C - for EXIT)"); getch();
      printf("\n\n Wait...");

      if ( fg_init() != FG_NULL ) {
        int           h_scr=fg.displaybox[FG_Y2]-fg.displaybox[FG_Y1],
                      w_scr=fg.displaybox[FG_X2]-fg.displaybox[FG_X1],
                      h_lin=h_scr/20,
                      h_smb=h_lin-h_lin/5,
                      h_ttl=h_scr/15,
                      Y    =h_scr-h_ttl-10,
                      k=0;
        unsigned char    ch=fi.CharStart,
                      end_c=fi.CharStart+((fi.CharsNum>=224)?223:fi.CharsNum);

        sprintf(buf,"This is %s font ( File : %s )",fi.FontName,fi.FileName);
        bgfDrawText( i, FG_WHITE, 0, Y, h_ttl, 0, buf );

        Y-=h_lin+h_lin;
        sprintf(buf,"0123456789 ABCXYZabcxyz  ...");
        bgfDrawText( i, FG_WHITE, 0, Y, h_smb, 0, buf );

        Y-=h_lin+h_lin;
        for ( ; ch < end_c; ch++ ) {
          buf[k++]=ch;
          if ( k==20 || ch==(end_c-1) ) {
            buf[k]='\0';  k=0;
            Y-=h_lin;
            bgfDrawText( i, FG_WHITE, 20, Y, h_smb, 1.5, buf );
          }
        }

        getch();
        fg_term();
      }
    }
  }

  return( 0 );
}



/*** end of BGFTEST.C ***/